package mvd.jester;

import java.util.Arrays;
import java.util.List;
import java.util.Set;
import mvd.jester.model.DagTask;
import mvd.jester.model.SortedTaskSet;
import mvd.jester.model.SystemManager;
import mvd.jester.model.SystemManager.DagTaskBuilder;
import mvd.jester.tests.AbstractTest;
import mvd.jester.tests.FonsecaNelis;
import mvd.jester.tests.JiangYi;
import mvd.jester.tests.MelaniButtazzo;
import mvd.jester.tests.SchmidMottok;
import mvd.jester.tests.Tester;
import mvd.jester.tests.TypeFunction.KnownStructureWithMaxThreads;
import mvd.jester.tests.TypeFunction.KnownStructure;
import mvd.jester.tests.TypeFunction.UnkownStructure;
import mvd.jester.tests.TypeFunction.TestFunction;


/**
 * Hello world!
 *
 */
public class App {
    public static void main(String[] args) {
        {
            SystemManager<DagTaskBuilder> manager = new SystemManager<>(DagTaskBuilder.class);
            manager.setNumberOfProcessors(32);
            TestEnvironment te = new TestEnvironment();

            List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
                    new SchmidMottok(new KnownStructureWithMaxThreads(manager), manager),
                    new Tester(new KnownStructure(), manager),
                    // new MelaniButtazzo(manager),
                    // new FonsecaNelis(manager)
                    new JiangYi(manager)));

            te.varyRenyiUtilization(manager, tests, 100);
        }
        // {
        // SystemManager<DagTaskBuilder> manager = new SystemManager<>(DagTaskBuilder.class);
        // TestEnvironment te = new TestEnvironment();

        // List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
        // new SchmidMottok(new KnownStructureWithMaxThreads(manager), manager),
        // new SchmidMottok(new KnownStructure(), manager)
        // // new MelaniButtazzo(manager)
        // , new FonsecaNelis(manager)
        // ));

        // te.varyUtilization(manager, tests, 500);
        // }
        // {
        // SystemManager<DagTaskBuilder> manager = new SystemManager<>(DagTaskBuilder.class);
        // TestEnvironment te = new TestEnvironment();

        // List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
        // new SchmidMottok(new KnownStructureWithMaxThreads(manager), manager),
        // new SchmidMottok(new KnownStructure(), manager),
        // // new MelaniButtazzo(manager),
        // // new FonsecaNelis(manager),
        // new JiangYi(manager)));

        // te.varyNumberOfProcessors(manager, tests, 500);
        // }
        // {
        // SystemManager manager = new SystemManager(8);
        // DagTaskBuilder builder = new DagTaskBuilder();
        // TestEnvironment te = new TestEnvironment();

        // List<AbstractTest<DagTask>> tests =
        // te.registerTests(Arrays.asList(new SchmidMottok(new UnkownStructure(), manager),
        // new SchmidMottok(new KownStructure(), manager),
        // new MelaniButtazzo(manager), new FonsecaNelis(manager)));

        // te.varyNumberOfTasks(builder, tests, 8, 500);
        // }
        // {
        // SystemManager manager = new SystemManager(8);
        // DagTaskBuilder builder = new DagTaskBuilder();
        // TestEnvironment te = new TestEnvironment();

        // List<AbstractTest<DagTask>> tests =
        // te.registerTests(Arrays.asList(new SchmidMottok(manager),
        // new MelaniButtazzo(manager), new FonsecaNelis(manager)));

        // te.measureExecutionTimes(builder, tests, manager, 500);
        // }
    }
}
